/* Copyright (c) 2016 SpaceToad and the BuildCraft team
 * 
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/. */
package buildcraft.transport.gui;

import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.GlStateManager.DestFactor;
import net.minecraft.client.renderer.GlStateManager.SourceFactor;
import net.minecraft.client.renderer.RenderHelper;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.resources.I18n;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;

import buildcraft.lib.gui.GuiBC8;
import buildcraft.lib.gui.GuiIcon;

import buildcraft.transport.BCTransportSprites;
import buildcraft.transport.container.ContainerFilteredBuffer_BC8;

public class GuiFilteredBuffer extends GuiBC8<ContainerFilteredBuffer_BC8> {
    private static final ResourceLocation TEXTURE_BASE = new ResourceLocation("buildcrafttransport:textures/gui/filtered_buffer.png");
    private static final int SIZE_X = 176, SIZE_Y = 169;
    private static final GuiIcon ICON_GUI = new GuiIcon(TEXTURE_BASE, 0, 0, SIZE_X, SIZE_Y);

    public GuiFilteredBuffer(ContainerFilteredBuffer_BC8 container) {
        super(container);
        field_146999_f = SIZE_X;
        field_147000_g = SIZE_Y;
    }

    @Override
    protected void drawBackgroundLayer(float partialTicks) {
        ICON_GUI.drawAt(mainGui.rootElement);
        RenderHelper.func_74520_c();
        for (int i = 0; i < 9; i++) {
            ItemStack stack = container.tile.invFilter.getStackInSlot(i);
            double currentX = mainGui.rootElement.getX() + 8 + i * 18;
            double currentY = mainGui.rootElement.getY() + 61;
            // GL11.glEnable(GL11.GL_BLEND);
            // GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
            // GL11.glColor4f(1, 1, 1, 0.5F);
            if (!stack.func_190926_b()) {
                this.field_146296_j.func_184391_a(this.field_146297_k.field_71439_g, stack, (int) currentX, (int) currentY);
            } else {
                this.field_146297_k.func_110434_K().func_110577_a(TextureMap.field_110575_b);
                this.func_175175_a((int) currentX, (int) currentY, BCTransportSprites.NOTHING_FILTERED_BUFFER_SLOT.getSprite(), 16, 16);
            }
            // GL11.glColor4f(1, 1, 1, 1);
            // GL11.glDisable(GL11.GL_BLEND);
        }
        RenderHelper.func_74518_a();
        // GL11.glPushMatrix();
        // GL11.glTranslatef(0, 0, 100);
        GlStateManager.func_179097_i();
        GlStateManager.func_179147_l();
        GlStateManager.func_187401_a(SourceFactor.SRC_ALPHA, DestFactor.ONE_MINUS_SRC_ALPHA);
        GlStateManager.func_179131_c(1, 1, 1, 0.7f);
        ICON_GUI.drawAt(mainGui.rootElement);

        GlStateManager.func_179131_c(1, 1, 1, 1);
        GlStateManager.func_179084_k();
        GlStateManager.func_179126_j();
        // GL11.glPopMatrix();
    }

    @Override
    protected void drawForegroundLayer() {
        int x = field_147003_i;
        int y = field_147009_r;
        String title = I18n.func_135052_a("tile.filteredBufferBlock.name");
        int xPos = (field_146999_f - field_146289_q.func_78256_a(title)) / 2;
        field_146289_q.func_78276_b(title, x + xPos, y + 10, 0x404040);
    }
}
